from argparse import ArgumentParser
from sys import stdout
import pandas as p

def main():
    parser = ArgumentParser(description='Transform a "pickle" to a csv file')
    parser.add_argument("-i", "--input",  dest="input",      help = "input pickle path",  metavar="PATH", required = True)
    parser.add_argument("-o", "--output", dest="output",     help = "output csv path", metavar="PATH")
    parser.add_argument("-r", "--row-names", dest = "rownames", help = "include row names in csv; if ommitted prints to stdout", action = "store_true")
    parser.add_argument("-v", "--verbose", dest = "verbose", action ="store_true")
    args = parser.parse_args()

    if args.output is None:
        args.output = stdout

    if args.verbose:
        print("Reading pickle")

    ptc = p.read_pickle(args.input)

    if args.verbose:
        print(ptc.info())
        print("Saving as csv")

    ptc.to_csv(args.output, index = args.rownames)


if __name__ == "__main__":
    main()
